Index: ecb-layout.el
===================================================================
RCS file: /pack/xemacscvs/XEmacs/packages/xemacs-packages/ecb/ecb-layout.el,v
retrieving revision 1.16
diff -u -r1.16 ecb-layout.el
--- ecb-layout.el	1 Dec 2004 16:05:01 -0000	1.16
+++ ecb-layout.el	16 Jan 2008 16:39:59 -0000
@@ -4523,13 +4523,17 @@
               (list ecb-frame ecb-layout-name ecb-compile-window-height
                     ecb-compile-window-width
                     ecb-windows-width ecb-windows-height))))
+
+(defvar ecb-cwc-advice-active t
+  "Gross hack to break an infinite loop in window configuration processing.
+When nil, the `current-window-configuration' advice does nothing.")
               
 (defadvice current-window-configuration (after ecb)
   "Stores some additional informations about the window-configurations needed
 by ECB."
   (condition-case oops
       (let ((f (or (ad-get-arg 0) (selected-frame))))
-        (when (equal f ecb-frame)
+        (when (and ecb-cwc-advice-active (equal f ecb-frame))
           (ecb-window-config-cache-add
            (list ad-return-value
                  (if ecb-windows-hidden
Index: ecb-util.el
===================================================================
RCS file: /pack/xemacscvs/XEmacs/packages/xemacs-packages/ecb/ecb-util.el,v
retrieving revision 1.13
diff -u -r1.13 ecb-util.el
--- ecb-util.el	1 Dec 2004 16:05:07 -0000	1.13
+++ ecb-util.el	16 Jan 2008 16:39:59 -0000
@@ -90,7 +90,7 @@
 ;;; ----- Some constants -----------------------------------
 
 ;;;###autoload
-(defconst ecb-running-xemacs (string-match "XEmacs\\|Lucid" emacs-version))
+(defconst ecb-running-xemacs (featurep 'xemacs))
 ;;;###autoload
 (defconst ecb-running-emacs-21 (and (not ecb-running-xemacs)
                                     (> emacs-major-version 20)))
@@ -1625,12 +1625,11 @@
 
 ;;; ----- Windows ------------------------------------------
 
-;; Emacs 20 has no window-list function and the XEmacs and Emacs 21 one has no
-;; specified ordering. The following one is stolen from XEmacs and has fixed
-;; this lack of a well defined order. We preserve also point of current
-;; buffer! IMPORTANT: When the window-ordering is important then currently
-;; these function should only be used with WINDOW = (frame-first-window
-;; ecb-frame)!
+;; Emacs 20 has no window-list function. The following one is stolen from
+;; XEmacs and has fixed this lack of a well defined order. We preserve also
+;; point of current buffer! IMPORTANT: When the window-ordering is important
+;; then currently these function should only be used with
+;; WINDOW = (frame-first-window ecb-frame)!
 (defun ecb-window-list (&optional frame minibuf window)
   "Return a list of windows on FRAME, beginning with WINDOW. The
 windows-objects in the result-list are in the same canonical windows-ordering
@@ -1638,13 +1637,14 @@
 WINDOW default to the selected ones. Optional second arg MINIBUF t means count
 the minibuffer window even if not active. If MINIBUF is neither t nor nil it
 means not to count the minibuffer even if it is active."
-  (if ecb-running-emacs-21
+  (if (or ecb-running-emacs-21 ecb-running-xemacs)
       ;; TODO: Klaus Berndl <klaus.berndl@sdm.de>: There seems to be
       ;; mysterious behavior when running our own window-list version with
       ;; GNU Emacs >= 21.3 - especially when running an igrep when the
-      ;; igrep-buffer is already in another window. We can here savely use the
-      ;; function `window-list' because it returns an ordered list
-      (window-list frame minibuf window)
+      ;; igrep-buffer is already in another window. We can safely use the
+      ;; function `window-list' here because it returns an ordered list
+      (let ((ecb-cwc-advice-active nil))
+	(window-list frame minibuf window))
     (setq window (or window (selected-window))
           frame (or frame (selected-frame)))
     (if (not (eq (window-frame window) frame))
